/***************************************************************************
                          clever.cpp  -  description
                             -------------------
    begin                : Don Apr 10 2003
    copyright            : (C) 2003 by Ingmar Bauer
 ***************************************************************************/

#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>


#define DEBUG

#include "matrix.h"

using namespace std;
 
#include "clever.h"

clever::clever(matrix<float> *m, int k=5) {
  this->a = m;
  this->size = a->n;
  this->k = k;

  cout << "Matrix size: " << size << endl;

  x = vector<float>(size);
  y = vector<float>(size);

  fill(x.begin(), x.end(), 1.0);
  fill(y.begin(), y.end(), 1.0);
}

clever::~clever() {
}

int clever::calc() {
  for(int i=0; i<=k; i++) {
    x_weight();
    y_weight();
    normalize(x);
    normalize(y);
  }
  return(k);
}

void clever::x_weight() {
  for(int j=0; j<size; j++) { // counter fuer die elemente von x
    x[j] = getYWeight(j);
  }
}

void clever::y_weight() {
  for(int j=0; j<size; j++) { // counter fuer die elemente von y
    y[j] = getXWeight(j);
  }
}

void clever::normalize(vector<float> &v) {
  int i=0;
  float a=0;

  for(i=0; i<size; i++) {
    a+=(v[i]*v[i]); // Summe der quadrate berechnen
  }

  for(i=0; i<size; i++) {
    v[i] = sqrt((float)(v[i]*v[i])/a);
  }
}

float clever::getYWeight(int x) {
  int i=0;
  float sum=0;

  // sum of the y-values of that pages
  for(i=0; i<size; i++) {
    if(a->m[x][i] != 0) {
      sum+=y[i];
    }
  }
  return(sum);
}

float clever::getXWeight(int y) {
  int i=0;
  float sum=0;

  // sum of the y-values of that pages
  for(i=0; i<size; i++) {
    if(a->m[i][y] != 0) {
      sum+=x[i];
    }
  }
  return(sum);
}

vector<float> clever::getAuthorities() {
  return(x);
}

vector<float> clever::getHubs() {
  return(y);
}
