/***************************************************************************
                          clever.h  -  description
                             -------------------
    begin                : Don Apr 10 2003
    copyright            : (C) 2003 by Ingmar Bauer
 ***************************************************************************/

#ifndef CLEVER_H
#define CLEVER_H


/**Implementation of Clever/HITS Algorithm
  *@author Ingmar Bauer
  */

class clever
{
public:
  clever(matrix<float> *m, int k);
  ~clever();

  int calc();
  vector<float> getAuthorities();
  vector<float> getHubs();

private:
  int k;
  int size;
  matrix<float> *a;	// pointer to original matrix

  vector<float> x;
  vector<float> y;
  float getXWeight(int y);
  float getYWeight(int x);
  void x_weight();
  void y_weight();
  void normalize(vector<float> &v);
};

#endif
