/***************************************************************************
                          datasource.h  -  description
                             -------------------
    begin                : Mon Mr 10 2003
    copyright            : (C) 2003 by Ingmar Bauer
 ***************************************************************************/


#ifndef DATASOURCE_H
#define DATASOURCE_H


/**Datasource class for Ranking Algorithms
  *@author Ingmar Bauer
  */

class datasource
{
public:
  datasource(string str_fname);
  ~datasource();

  int getRefs();
  int nextRef(unsigned int &src_id, vector<int> &lnk_ids);
  int nextRef(unsigned int &src_id, vector<int> &lnk_ids, vector<int> &backlnk_ids);
  string getURL(unsigned int id);

  int getMatrixSize(void);
  int getAdjMatrix(matrix<float> &m);                     // get pagerank needed matrix
  int getAdjascencyMatrix(matrix<float> &m);  // get real adjascency matrix

  bool ready;

private:
  std::ifstream *f_index;
  std::ifstream *f_refs;
  std::ifstream *f_url;
  std::ifstream *f_irefs;

  unsigned int offs_ref;
  unsigned int offs_url;
  unsigned int offs_iref;
  unsigned short n_refs;
  unsigned short n_irefs;

  unsigned int size;
};

#endif
