/***************************************************************************
                          salsa.h  -  description
                             -------------------
    begin                : Mon Mr 10 2003
    copyright            : (C) 2003 by Ingmar Bauer
 ***************************************************************************/

#ifndef SALSA_H
#define SALSA_H


/**Stochastic Approach for Link Structure Analysis
  *@author Ingmar Bauer
  */

class salsa {
public: 
  salsa(datasource &ds);
  salsa(matrixsource &ms, float c, float eps);
  ~salsa();
  int createMatrices();
  int saveMatrices(string fname);
  vector<float> calc();
  vector<float> calc_eigenvector();

private:
  int size;
  datasource *ds;
  matrixsource *ms;
  matrix<float> adj;	// pointer to adjascent matrix

  matrix<float> hub;
  /** dampening factor */
  float c;
  float eps;
  matrix<float> auth;
};

#endif
