#!/usr/bin/perl -w

#
# Ingmar Bauer
#

use strict;
use DBI;


# Datenbankroutinen
my $dbname = 'testsuite_c64';
my $dbuser   = 'root';
my $dbpasswd = '';
my $driver;
my $dbh;
    
$driver = DBI->install_driver('mysql');
if(!$driver) {
    return(0);
}

$dbh = $driver->connect($dbname, $dbuser, $dbpasswd);
if(!$dbh) {
    return(0);
}


# Fileroutinen

open(f_index, ">c64.idx") or die("index not open");
open(f_refs, ">c64.ref") or die("refs not open");
open(f_url, ">c64.url") or die("urls not open");

# inverse index
open(f_invidx, "<c64.inv.idx") or die("inverse index not open");
#open(f_invref, "<test.inv.ref") or die("inverse refs not open");

# copy process
my $src_id;
my @lnk_ids = ();
my $url;

#my $sql1 = "SELECT u.id,u.url,l.lnk_ids FROM lnk AS l,url AS u WHERE u.id = l.src_id ORDER BY u.id";
my $sql1 = "SELECT u.id,u.url FROM url AS u ORDER BY u.id";
my $sth = $dbh->prepare($sql1);
if($sth) {
    $sth->execute();
    
    my @row = ();
    while( (@row = $sth->fetchrow())) {
	$src_id = $row[0];
	$url = $row[1];
	
	# get refs
	@lnk_ids = ();
	my $sql2 = "SELECT lnk_ids FROM lnk WHERE src_id=$src_id";
	my $sth2 = $dbh->prepare($sql2);
	$sth2->execute();
	if( (my @row2 = $sth2->fetchrow()) ) {
	    @lnk_ids = split(/,/, $row2[0]);
	}
	$sth2->finish();
	
	# write out to file
	print f_index pack("I", $src_id-1);
	print f_index pack("I", tell(f_refs));
	print f_index pack("S", scalar(@lnk_ids));
	print f_index pack("I", tell(f_url));

	# get data from inverse index and add in
	my $inv_offsrefs;
	my $inv_noffs;
	if(!(&getFromInvIdx($src_id-1, \$inv_offsrefs, \$inv_noffs))) {
	    $inv_offsrefs = 0;
	    $inv_noffs = 0;
	}
	
	print f_index pack("IS", $inv_offsrefs, $inv_noffs);
	
	my $id;
	foreach $id (@lnk_ids) {	
	    print f_refs pack("I", $id-1);
	}
	
	print f_url "$url\n";
    }
    $sth->finish();
}









close(f_index);
close(f_refs);
close(f_url);

#close(f_invref);
close(f_invidx);

$dbh->disconnect();


sub getFromInvIdx() {
    my ($src_id, $offs, $n) = @_;
    my $help = 0;
    my $id = 0;
    my $dummy;
        
    seek(f_invidx, 0, 0);
    
    do {
	read(f_invidx, $help, length(pack("IISI", 0, 0, 0, 0)));
	
	($id, $$offs, $$n, $dummy) = unpack("IISI", $help);
	
	
	if($id == $src_id) {
	    if($src_id == 1) {
		print "1offs: $$offs\n";
	        print "1n: $$n\n";
	    }

	    return 1;
	}
	
    } while(!eof(f_invidx));
	
    return 0;
}