#!/usr/bin/perl

#
# Ingmar Bauer
#


#
# this one downloads the documents and saves it to the repository db
#

use strict;
use DBI;
#require "lib/httpnew.pl";
require "cgi/http.pl";
require "cgi/mycgi.pl";

my $dbuser = 'root';
my $dbpasswd = '';
my $dbname = 'testsuite_c64';
my $dbtable = 'pages';

my $db_driver;
my $dbh;

sub connectDB() {
    # database connection
    $db_driver = DBI->install_driver('mysql');
    if(!$db_driver) {
	print("Error connecting to database.\n");
	return 0;
    }

    $dbh = $db_driver->connect($dbname, $dbuser, $dbpasswd);
    if(!$dbh) {
	print("Error connecting to database.\n");
	return 0;
    }
    return 1;
}

sub disconnectDB() {
    $dbh->disconnect();
}


sub getPage() {
    my $url = shift;
    
    my $host = "";
    my $remote_path = "";
    my $vars_encoded = "";
    my $port = 80;
    my $method = 'GET';
    my $timeout = 60;
    my $connect_timeout = 30;

    my $page;
    
#    if($url =~ m|http:\/\/(.+?)\/(.+?)\?(.+?)$|is) {
#	$host = $1;
#	$remote_path = $2;
#	$vars_encoded = $3;
#	$url = "http://$host:$port$remote_path?$vars_encoded";
#    } elsif($url =~ m|http:\/\/(.+?)\/(.+?)$|is) {
#	$host = $1;
#	$remote_path = $2;
#	$url = "http://$host:$port$remote_path";
#    } elsif($url =~ m|http:\/\/(.+?)$|is) {
#	$host = $1;
#	$url = "http://$host:$port";
#    }
    
    
    #print "URL: $url\n";

    #$page = &HTTP_new($url, $method, $port, $timeout, $connect_timeout);
    #$page = &HTTP($remote_path, $host, $port, $method, $timeout, $vars_encoded);
    $page = `wget -t 1 -O - $url`;

    #sleep(2);
    return $page;
}

sub clearDocs() {
    my $sql_statement = "DELETE FROM $dbtable";
    $dbh->do($sql_statement);
    my $sql_statement = "DELETE FROM url";
    $dbh->do($sql_statement);

}

sub getDocs() {
    my $url;
    my $page;
    my $i=0;
    my $sql_statement;
    
        
    open(URLFILE, "<url.txt") or die("Can't open URL-File!");
    
    while( ($url = readline(*URLFILE)) ) {
	print("($i) retrieving $url...\n");
	
	$page = &getPage($url);
	$page = $dbh->quote($page);
	#$page =~ s|\'|\\'|isg;
	
	#
	my $helpurl = $url;
	chomp($helpurl);
	$helpurl = $dbh->quote($helpurl);
	
	
	$sql_statement = "INSERT INTO url (url) VALUES($helpurl)";
	$dbh->do($sql_statement) or die $dbh->errstr();
	
	$sql_statement = "SELECT LAST_INSERT_ID()";
	my $sth = $dbh->prepare($sql_statement);
	$sth->execute() or die $dbh->errstr();
	
	my @row = $sth->fetchrow();
	my $doc_id = $row[0];
	$sth->finish();
	#
	
	$sql_statement = "INSERT INTO $dbtable (doc_id, doc_data) VALUES($doc_id, $page)";
	my $sth = $dbh->prepare($sql_statement) or die $dbh->errstr;
	$sth->execute() or die $dbh->errstr;
	
	#if($dbh->err()) {
	#    print("Error executing SQL-Command.\n");
	#    print "$dbh->errstr()\n";
	#    return(0);
	#}
	$i++;
    }
    
    close(URLFILE);
    return(1);
}


#
# main
#


# build up a URL-Database using Results from metacrawler.de
# first get a result set and save the given links into url-database
# use keywordlist for that...
# ca. 150 results per keyword -> 40 keywords -> 6000 pages

#die("getdocs: db checken!!!!");

if(!&connectDB()) {
    print "Error connecting to database!\n";
    exit(0);
}

&clearDocs();

if(!&getDocs()) {
    print("Error getting documents!\n");
}

&disconnectDB();
print("done.\n");

exit(1);
