/*****************************************************************************/
/*** Masterprocess				       			   ***/
/***-----------------------------------------------------------------------***/
/*** Ingmar Bauer / metacrawler.de					   ***/
/*** 2002-09-03								   ***/
/*****************************************************************************/
using namespace std;

#include <iostream>
#include <vector>
//#include <sqlplus.hh>
#include <algorithm>

#include "matrix.h"
#include "datasource.h"

//#include "pr.h"
#include "pagerank_opt.h"
//#include "clever.h"
//#include "linkcount.h"

int main(int argc, char *argv[]) {

    //datasource ds("testsuite_syn1", "localhost", "root", "");
    datasource ds("simple");
    cout << "DataSource created." << endl;

    //int size = 3;
    int size = ds.getMatrixSize();
    cout << "Matrix size: " << size << endl;
    
    matrix<float> adjMat(size);
    cout << "Matrix created." << endl;
    //cout << "1adjMat.n: " << adjMat.n << endl;
    //cout << "1adjMat.m[5][0]: " << adjMat.m[5][0] << endl;    

    /*
    adjMat.m[0][0] = 0.5;
    adjMat.m[0][1] = 0;
    adjMat.m[0][2] = 0;

    adjMat.m[1][0] = 0;
    adjMat.m[1][1] = 1.5;
    adjMat.m[1][2] = .5;
    
    adjMat.m[2][0] = 0;
    adjMat.m[2][1] = .25;
    adjMat.m[2][2] = .5;
    */
    
//    ds.getAdjMatrix(adjMat);


    //cout << "2adjMat.n: " << adjMat.n << endl;
    //cout << "2adjMat.m[5][0]: " << adjMat.m[5][0] << endl;    

    
    // PageRank
    pagerank_opt pr2(ds, .85, .0001);
    vector<float> res = pr2.calc();
    

    //PageRank pr(&adjMat, .85, .1);
    //vector<float> res = pr.calc();


    
    //Clever clever(&adjMat, 5);
    //clever.calc();
    //vector<float> res = clever.getHubs(); //getAuthorities();
    
    
//    LinkCount lcount(&adjMat);
//    vector<float> res = lcount.calc();

    
    cout << "calculated." << endl;    


    // Create new order-vector
    vector<float> order(size);
    for(int i=0; i<size; i++) {
	order[i] = i;
    }
    //generate(order.begin(), order.end(), inc(i));
    
    cout << "bubble sort...\n";
    // bubble sort
    int i, j=size;
    while(j > 0) {
	for(i=1; i<j; i++) {
	    if(res[i-1] < res[i]) {
		swap(res[i], res[i-1]);
		swap(order[i], order[i-1]);
	    }
	}
	j--;
    }
    
    cout << "order[0]" << order[0] << endl;
    
    // print results according to order vector
    for(i=0; i<size; i++) {
	cout << res[i] << ": " << ds.getURL((int)order[i]) << endl;
//	cout << res[i] << ": " << order[i] << endl;
    }
        
    
    //cout << "3adjMat.n: " << adjMat.n << endl;
    //cout << "3adjMat.m[5][0]: " << adjMat.m[5][0] << endl;    
    

/*
    matrix<float> adjMat(3);
    adjMat.m[0][0] = 0.0;
    adjMat.m[1][0] = 0.5;
    adjMat.m[2][0] = 0.5;
    adjMat.m[0][1] = 1.0;
    adjMat.m[1][1] = 0.0;
    adjMat.m[2][1] = 0.0;
    adjMat.m[0][2] = 1.0;
    adjMat.m[1][2] = 0.0;
    adjMat.m[2][2] = 0.0;

    adjMat.print();
        
    PageRank pr(&adjMat);
    vector<float> res = pr.calc();

    vector<float>::iterator it;
    for(it=res.begin(); it!=res.end(); it++) {
	cout << *it << endl;
    }
        
    adjMat.print();
*/    
    return(1);
}
