/***************************************************************************
                          matrixsource.cpp  -  description
                             -------------------
    begin                : Mit Apr 2 2003
    copyright            : (C) 2003 by Ingmar Bauer
    email                : ingmar@metacrawler.de
 ***************************************************************************/

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include "matrixsource.h"

matrixsource::matrixsource(string fname) {
  this->fname = fname;

  f_matrix = new ifstream(fname.c_str(), ios_base::in | ios_base::binary);
  if(!*f_matrix) {
    cerr << "matrixsource::matrixsource(string fname): Couldn't open file " << fname << "." << endl;
  }

  f_matrix->read((char *)&n, 4);
  if(!*f_matrix) {
    cerr << "matrixsource::matrixsource(string fname): Couldn't read matrix size from file " << fname << "." << endl;
  }
  n_el=0;
}

matrixsource::~matrixsource() {
  if(f_matrix->is_open()) {
    f_matrix->close();
  }
}

void matrixsource::reInitMatrix() {
  f_matrix->clear();
  f_matrix->seekg(0, ios_base::beg);
  f_matrix->read((char *)&n, 4);
  if(!*f_matrix) {
    cerr << "matrixsource::reInitMatrix(): Couldn't read matrix size from file " << fname << "." << endl;
  }
  n_el=0;
}

int matrixsource::prepareNextRow(int &line) {
  if(n_el == 0) { // allow this only if all elements are read already
    f_matrix->read((char *)&line, 4);
    f_matrix->read((char *)&n_el, 4);

    return n_el;
  }
  return 0;
}

int matrixsource::getNextRowEl(matrix_element &el) {

  if(n_el > 0) { // allow this only if block was prepared before
    f_matrix->read((char *)&el.col, 4);
    f_matrix->read((char *)&el.value, 4);
    n_el--;
    return (n_el+1);
  }
  
  return 0;
}

int matrixsource::getSize() {
  return n;
}
